Index: LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90	(revision 5098)
@@ -368,308 +365,302 @@
     !######################################################################
 
-    DO k=1,klev
-       DO i=1,klon
-          sourceBE(i,k)=0.
-          Mint(i,k)=0.
-          zrho(i,k)=0.
-          zdz(i,k)=0.
-       ENDDO
+    DO k = 1, klev
+      DO i = 1, klon
+        sourceBE(i, k) = 0.
+        Mint(i, k) = 0.
+        zrho(i, k) = 0.
+        zdz(i, k) = 0.
+      ENDDO
     ENDDO
 
-    DO it=1, nbtr
-       DO k=1,klev
-          DO i=1,klon
-             d_tr_insc(i,k,it)=0.
-             d_tr_bcscav(i,k,it)=0.
-             d_tr_evapls(i,k,it)=0.
-             d_tr_ls(i,k,it)=0.
-             d_tr_cv(i,k,it)=0.
-             d_tr_cl(i,k,it)=0.
-             d_tr_trsp(i,k,it)=0.
-             d_tr_sscav(i,k,it)=0.
-             d_tr_sat(i,k,it)=0.
-             d_tr_uscav(i,k,it)=0.
-             d_tr_lessi_impa(i,k,it)=0.
-             d_tr_lessi_nucl(i,k,it)=0.
-             qDi(i,k,it)=0.
-             qPr(i,k,it)=0.
-             qPa(i,k,it)=0.
-             qMel(i,k,it)=0.
-             qTrdi(i,k,it)=0.
-             dtrcvMA(i,k,it)=0.
-             zmfd1a(i,k,it)=0.
-             zmfdam(i,k,it)=0.
-             zmfphi2(i,k,it)=0.
-          ENDDO
-       ENDDO
+    DO it = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_insc(i, k, it) = 0.
+          d_tr_bcscav(i, k, it) = 0.
+          d_tr_evapls(i, k, it) = 0.
+          d_tr_ls(i, k, it) = 0.
+          d_tr_cv(i, k, it) = 0.
+          d_tr_cl(i, k, it) = 0.
+          d_tr_trsp(i, k, it) = 0.
+          d_tr_sscav(i, k, it) = 0.
+          d_tr_sat(i, k, it) = 0.
+          d_tr_uscav(i, k, it) = 0.
+          d_tr_lessi_impa(i, k, it) = 0.
+          d_tr_lessi_nucl(i, k, it) = 0.
+          qDi(i, k, it) = 0.
+          qPr(i, k, it) = 0.
+          qPa(i, k, it) = 0.
+          qMel(i, k, it) = 0.
+          qTrdi(i, k, it) = 0.
+          dtrcvMA(i, k, it) = 0.
+          zmfd1a(i, k, it) = 0.
+          zmfdam(i, k, it) = 0.
+          zmfphi2(i, k, it) = 0.
+        ENDDO
+      ENDDO
     ENDDO
 
-    DO it=1, nbtr
-       DO i=1,klon
-          d_tr_dry(i,it)=0.
-          flux_tr_dry(i,it)=0.
-       ENDDO
+    DO it = 1, nbtr
+      DO i = 1, klon
+        d_tr_dry(i, it) = 0.
+        flux_tr_dry(i, it) = 0.
+      ENDDO
     ENDDO
 
     DO k = 1, klev
-       DO i = 1, klon
-          delp(i,k) = paprs(i,k)-paprs(i,k+1)
-       ENDDO
+      DO i = 1, klon
+        delp(i, k) = paprs(i, k) - paprs(i, k + 1)
+      ENDDO
     ENDDO
 
     IF (debutphy) THEN
-       !!jyg
-!$OMP BARRIER
-       ecrit_tra=86400. ! frequence de stokage en dur
-       ! obsolete car remplace par des ecritures dans phys_output_write
-       !RomP >>>
-       !
-       !Config Key  = convscav
-       !Config Desc = Convective scavenging switch: 0=off, 1=on.
-       !Config Def  = .FALSE.
-       !Config Help = 
-       !
-!$OMP MASTER
-       convscav_omp=.FALSE.
-       call getin('convscav', convscav_omp)
-       iflag_vdf_trac_omp=1
-       call getin('iflag_vdf_trac', iflag_vdf_trac_omp)
-       iflag_con_trac_omp=1
-       call getin('iflag_con_trac', iflag_con_trac_omp)
-       iflag_the_trac_omp=1
-       call getin('iflag_the_trac', iflag_the_trac_omp)
-!$OMP END MASTER
-!$OMP BARRIER
-       convscav=convscav_omp
-       iflag_vdf_trac=iflag_vdf_trac_omp
-       iflag_con_trac=iflag_con_trac_omp
-       iflag_the_trac=iflag_the_trac_omp
-       write(lunout,*) 'phytrac passage dans routine conv avec lessivage', convscav
-       !
-       !Config Key  = iflag_lscav
-       !Config Desc = Large scale scavenging parametrization: 0=none, 1=old(Genthon92),
-       !              2=1+PHeinrich, 3=Reddy_Boucher2004, 4=3+RPilon.
-       !Config Def  = 1
-       !Config Help = 
-       !
-!$OMP MASTER
-       iflag_lscav_omp=1
-       call getin('iflag_lscav', iflag_lscav_omp)
-       ccntrAA_omp=1
-       ccntrENV_omp=1.
-       coefcoli_omp=0.001
-       call getin('ccntrAA', ccntrAA_omp)
-       call getin('ccntrENV', ccntrENV_omp)
-       call getin('coefcoli', coefcoli_omp)
-!$OMP END MASTER
-!$OMP BARRIER
-       iflag_lscav=iflag_lscav_omp
-       ccntrAA_in=ccntrAA_omp
-       ccntrENV_in=ccntrENV_omp
-       coefcoli_in=coefcoli_omp
-       !
-       SELECT CASE(iflag_lscav)
-       CASE(0)
-          WRITE(lunout,*)  'Large scale scavenging: none'
-       CASE(1)
-          WRITE(lunout,*)  'Large scale scavenging: C. Genthon, Tellus(1992), 44B, 371-389'
-       CASE(2)
-          WRITE(lunout,*)  'Large scale scavenging: C. Genthon, modified P. Heinrich'
-       CASE(3)
-          WRITE(lunout,*)  'Large scale scavenging: M. Shekkar Reddy and O. Boucher, JGR(2004), 109, D14202'
-       CASE(4)
-          WRITE(lunout,*)  'Large scale scavenging: Reddy and Boucher, modified R. Pilon'
-       END SELECT
-       !RomP <<<
-       WRITE(*,*) 'FIRST TIME IN PHYTRAC : pdtphys(sec) = ',pdtphys,'ecrit_tra (sec) = ',ecrit_tra
-       ALLOCATE( source(klon,nbtr), stat=ierr)
-       IF (ierr /= 0) CALL abort_physic('phytrac', 'pb in allocation 1',1)
-
-       ALLOCATE( aerosol(nbtr), stat=ierr)
-       IF (ierr /= 0) CALL abort_physic('phytrac', 'pb in allocation 2',1)
-
-
-       ! Initialize module for specific tracers
-       IF (type_trac == 'inca') THEN
-          source(:,:)=init_source(:,:)
-          CALL tracinca_init(aerosol,lessivage)
-       ELSE IF (type_trac == 'repr') THEN
-          source(:,:)=0.
-       ELSE IF (type_trac == 'co2i') THEN
-          source(:,:)=0.
-          lessivage  = .FALSE.
-          aerosol(:) = .FALSE.
-          pbl_flg(:) = 1
-          iflag_the_trac= 1
-          iflag_vdf_trac= 1
-          iflag_con_trac= 1
-       ELSE IF (type_trac == 'inco') THEN
-          source(:,1:nqCO2) = 0.                          ! from CO2i ModThL
-          source(:,nqCO2+1:nbtr)=init_source(:,:)         ! from INCA ModThL
-          aerosol(1:nqCO2) = .FALSE.                      ! from CO2i ModThL
-          CALL tracinca_init(aerosol(nqCO2+1:nbtr),lessivage)     ! from INCA ModThL
-          pbl_flg(1:nqCO2) = 1                            ! From CO2i ModThL
-          iflag_the_trac = 1                              ! From CO2i
-          iflag_vdf_trac = 1                              ! From CO2i
-          iflag_con_trac = 1                              ! From CO2i
-#ifdef CPP_StratAer
-       ELSE IF (type_trac == 'coag') THEN
-          source(:,:)=0.
-          CALL tracstrataer_init(aerosol,lessivage)       ! init aerosols and lessivage param
-#endif
-       ELSE IF (type_trac == 'lmdz') THEN
-          CALL traclmdz_init(pctsrf,xlat,xlon,ftsol,tr_seri,t_seri,pplay,sh,pdtphys,aerosol,lessivage)
-       ENDIF
-
-       !
-       !--initialising coefficients for scavenging in the case of NP
-       !
-       ALLOCATE(flag_cvltr(nbtr))
-       IF (iflag_con==3) THEN
-          !
-          ALLOCATE(ccntrAA(nbtr))
-          ALLOCATE(ccntrENV(nbtr))
-          ALLOCATE(coefcoli(nbtr))
-          !
-          DO it=1, nbtr
-             IF (type_trac == 'repr') THEN
-                 flag_cvltr(it)=.FALSE.
-             ELSE IF (type_trac == 'inca') THEN
-!                IF ((it.EQ.id_Rn222) .OR. ((it.GE.id_SO2) .AND. (it.LE.id_NH3)) ) THEN 
-!                   !--gas-phase species
-!                   flag_cvltr(it)=.FALSE.
-!
-!                ELSEIF ( (it.GE.id_CIDUSTM) .AND. (it.LE.id_AIN) ) THEN
-!                   !--insoluble aerosol species
-!                   flag_cvltr(it)=.TRUE.
-!                   ccntrAA(it)=0.7
-!                   ccntrENV(it)=0.7
-!                   coefcoli(it)=0.001
-!                ELSEIF ( (it.EQ.id_Pb210) .OR. ((it.GE.id_CSSSM) .AND. (it.LE.id_SSN))) THEN
-!                   !--soluble aerosol species
-!                   flag_cvltr(it)=.TRUE.
-!                   ccntrAA(it)=0.9
-!                   ccntrENV(it)=0.9 
-!                   coefcoli(it)=0.001
-!                ELSE 
-!                   WRITE(lunout,*) 'pb it=', it
-!                   CALL abort_physic('phytrac','pb it scavenging',1)
-!                ENDIF
-                !--test OB 
-                !--for now we do not scavenge in cvltr
-                flag_cvltr(it)=.FALSE.
-             ELSE IF (type_trac == 'co2i') THEN
-                !--co2 tracers are not scavenged
-                flag_cvltr(it)=.FALSE.
-             ELSE IF (type_trac == 'inco') THEN     ! Add ThL
-                flag_cvltr(it)=.FALSE.
-#ifdef CPP_StratAer
-             ELSE IF (type_trac == 'coag') THEN
-                IF (convscav.and.aerosol(it)) THEN
-                   flag_cvltr(it)=.TRUE.
-                   ccntrAA(it) =ccntrAA_in    
-                   ccntrENV(it)=ccntrENV_in
-                   coefcoli(it)=coefcoli_in
-                ELSE
-                   flag_cvltr(it)=.FALSE.
-                ENDIF
-#endif
-             ELSE IF (type_trac == 'lmdz') THEN
-                IF (convscav.and.aerosol(it)) THEN
-                   flag_cvltr(it)=.TRUE.
-                   ccntrAA(it) =ccntrAA_in    !--a modifier par JYG a lire depuis fichier 
-                   ccntrENV(it)=ccntrENV_in
-                   coefcoli(it)=coefcoli_in
-                ELSE 
-                   flag_cvltr(it)=.FALSE.
-                ENDIF
-             ENDIF
-          ENDDO
-          !
-       ELSE ! iflag_con .ne. 3 
-          flag_cvltr(:) = .FALSE. 
-       ENDIF
-       !
-       ! print out all tracer flags 
-       !
-       WRITE(lunout,*) 'print out all tracer flags'
-       WRITE(lunout,*) 'type_trac      =', type_trac
-       WRITE(lunout,*) 'config_inca    =', config_inca
-       WRITE(lunout,*) 'iflag_con_trac =', iflag_con_trac
-       WRITE(lunout,*) 'iflag_con      =', iflag_con
-       WRITE(lunout,*) 'convscav       =', convscav
-       WRITE(lunout,*) 'iflag_lscav    =', iflag_lscav
-       WRITE(lunout,*) 'aerosol        =', aerosol
-       WRITE(lunout,*) 'iflag_the_trac =', iflag_the_trac
-       WRITE(lunout,*) 'iflag_thermals =', iflag_thermals
-       WRITE(lunout,*) 'iflag_vdf_trac =', iflag_vdf_trac
-       WRITE(lunout,*) 'pbl_flg        =', pbl_flg
-       WRITE(lunout,*) 'lessivage      =', lessivage
-       write(lunout,*)  'flag_cvltr    = ', flag_cvltr
-
-       IF (lessivage .AND. ANY(type_trac == ['inca','inco'])) &
-          CALL abort_physic('phytrac', 'lessivage=T config_inca=inca impossible',1)
-       !
+      !!jyg
+      !$OMP BARRIER
+      ecrit_tra = 86400. ! frequence de stokage en dur
+      ! obsolete car remplace par des ecritures dans phys_output_write
+      !RomP >>>
+      !
+      !Config Key  = convscav
+      !Config Desc = Convective scavenging switch: 0=off, 1=on.
+      !Config Def  = .FALSE.
+      !Config Help =
+      !
+      !$OMP MASTER
+      convscav_omp = .FALSE.
+      call getin('convscav', convscav_omp)
+      iflag_vdf_trac_omp = 1
+      call getin('iflag_vdf_trac', iflag_vdf_trac_omp)
+      iflag_con_trac_omp = 1
+      call getin('iflag_con_trac', iflag_con_trac_omp)
+      iflag_the_trac_omp = 1
+      call getin('iflag_the_trac', iflag_the_trac_omp)
+      !$OMP END MASTER
+      !$OMP BARRIER
+      convscav = convscav_omp
+      iflag_vdf_trac = iflag_vdf_trac_omp
+      iflag_con_trac = iflag_con_trac_omp
+      iflag_the_trac = iflag_the_trac_omp
+      write(lunout, *) 'phytrac passage dans routine conv avec lessivage', convscav
+      !
+      !Config Key  = iflag_lscav
+      !Config Desc = Large scale scavenging parametrization: 0=none, 1=old(Genthon92),
+      !              2=1+PHeinrich, 3=Reddy_Boucher2004, 4=3+RPilon.
+      !Config Def  = 1
+      !Config Help =
+      !
+      !$OMP MASTER
+      iflag_lscav_omp = 1
+      call getin('iflag_lscav', iflag_lscav_omp)
+      ccntrAA_omp = 1
+      ccntrENV_omp = 1.
+      coefcoli_omp = 0.001
+      call getin('ccntrAA', ccntrAA_omp)
+      call getin('ccntrENV', ccntrENV_omp)
+      call getin('coefcoli', coefcoli_omp)
+      !$OMP END MASTER
+      !$OMP BARRIER
+      iflag_lscav = iflag_lscav_omp
+      ccntrAA_in = ccntrAA_omp
+      ccntrENV_in = ccntrENV_omp
+      coefcoli_in = coefcoli_omp
+      !
+      SELECT CASE(iflag_lscav)
+      CASE(0)
+        WRITE(lunout, *)  'Large scale scavenging: none'
+      CASE(1)
+        WRITE(lunout, *)  'Large scale scavenging: C. Genthon, Tellus(1992), 44B, 371-389'
+      CASE(2)
+        WRITE(lunout, *)  'Large scale scavenging: C. Genthon, modified P. Heinrich'
+      CASE(3)
+        WRITE(lunout, *)  'Large scale scavenging: M. Shekkar Reddy and O. Boucher, JGR(2004), 109, D14202'
+      CASE(4)
+        WRITE(lunout, *)  'Large scale scavenging: Reddy and Boucher, modified R. Pilon'
+      END SELECT
+      !RomP <<<
+      WRITE(*, *) 'FIRST TIME IN PHYTRAC : pdtphys(sec) = ', pdtphys, 'ecrit_tra (sec) = ', ecrit_tra
+      ALLOCATE(source(klon, nbtr), stat = ierr)
+      IF (ierr /= 0) CALL abort_physic('phytrac', 'pb in allocation 1', 1)
+
+      ALLOCATE(aerosol(nbtr), stat = ierr)
+      IF (ierr /= 0) CALL abort_physic('phytrac', 'pb in allocation 2', 1)
+
+
+      ! Initialize module for specific tracers
+      IF (type_trac == 'inca') THEN
+        source(:, :) = init_source(:, :)
+        CALL tracinca_init(aerosol, lessivage)
+      ELSE IF (type_trac == 'repr') THEN
+        source(:, :) = 0.
+      ELSE IF (type_trac == 'co2i') THEN
+        source(:, :) = 0.
+        lessivage = .FALSE.
+        aerosol(:) = .FALSE.
+        pbl_flg(:) = 1
+        iflag_the_trac = 1
+        iflag_vdf_trac = 1
+        iflag_con_trac = 1
+      ELSE IF (type_trac == 'inco') THEN
+        source(:, 1:nqCO2) = 0.                          ! from CO2i ModThL
+        source(:, nqCO2 + 1:nbtr) = init_source(:, :)         ! from INCA ModThL
+        aerosol(1:nqCO2) = .FALSE.                      ! from CO2i ModThL
+        CALL tracinca_init(aerosol(nqCO2 + 1:nbtr), lessivage)     ! from INCA ModThL
+        pbl_flg(1:nqCO2) = 1                            ! From CO2i ModThL
+        iflag_the_trac = 1                              ! From CO2i
+        iflag_vdf_trac = 1                              ! From CO2i
+        iflag_con_trac = 1                              ! From CO2i
+      ELSE IF (type_trac == 'coag' .AND. CPPKEY_STRATAER) THEN
+        source(:, :) = 0.
+        CALL tracstrataer_init(aerosol, lessivage)       ! init aerosols and lessivage param
+      ELSE IF (type_trac == 'lmdz') THEN
+        CALL traclmdz_init(pctsrf, xlat, xlon, ftsol, tr_seri, t_seri, pplay, sh, pdtphys, aerosol, lessivage)
+      ENDIF
+
+      !
+      !--initialising coefficients for scavenging in the case of NP
+      !
+      ALLOCATE(flag_cvltr(nbtr))
+      IF (iflag_con==3) THEN
+        !
+        ALLOCATE(ccntrAA(nbtr))
+        ALLOCATE(ccntrENV(nbtr))
+        ALLOCATE(coefcoli(nbtr))
+        !
+        DO it = 1, nbtr
+          IF (type_trac == 'repr') THEN
+            flag_cvltr(it) = .FALSE.
+          ELSE IF (type_trac == 'inca') THEN
+            !                IF ((it.EQ.id_Rn222) .OR. ((it.GE.id_SO2) .AND. (it.LE.id_NH3)) ) THEN
+            !                   !--gas-phase species
+            !                   flag_cvltr(it)=.FALSE.
+            !
+            !                ELSEIF ( (it.GE.id_CIDUSTM) .AND. (it.LE.id_AIN) ) THEN
+            !                   !--insoluble aerosol species
+            !                   flag_cvltr(it)=.TRUE.
+            !                   ccntrAA(it)=0.7
+            !                   ccntrENV(it)=0.7
+            !                   coefcoli(it)=0.001
+            !                ELSEIF ( (it.EQ.id_Pb210) .OR. ((it.GE.id_CSSSM) .AND. (it.LE.id_SSN))) THEN
+            !                   !--soluble aerosol species
+            !                   flag_cvltr(it)=.TRUE.
+            !                   ccntrAA(it)=0.9
+            !                   ccntrENV(it)=0.9
+            !                   coefcoli(it)=0.001
+            !                ELSE
+            !                   WRITE(lunout,*) 'pb it=', it
+            !                   CALL abort_physic('phytrac','pb it scavenging',1)
+            !                ENDIF
+            !--test OB
+            !--for now we do not scavenge in cvltr
+            flag_cvltr(it) = .FALSE.
+          ELSE IF (type_trac == 'co2i') THEN
+            !--co2 tracers are not scavenged
+            flag_cvltr(it) = .FALSE.
+          ELSE IF (type_trac == 'inco') THEN     ! Add ThL
+            flag_cvltr(it) = .FALSE.
+          ELSE IF (type_trac == 'coag' .AND. CPPKEY_STRATAER) THEN
+            IF (convscav.and.aerosol(it)) THEN
+              flag_cvltr(it) = .TRUE.
+              ccntrAA(it) = ccntrAA_in
+              ccntrENV(it) = ccntrENV_in
+              coefcoli(it) = coefcoli_in
+            ELSE
+              flag_cvltr(it) = .FALSE.
+            ENDIF
+          ELSE IF (type_trac == 'lmdz') THEN
+            IF (convscav.and.aerosol(it)) THEN
+              flag_cvltr(it) = .TRUE.
+              ccntrAA(it) = ccntrAA_in    !--a modifier par JYG a lire depuis fichier
+              ccntrENV(it) = ccntrENV_in
+              coefcoli(it) = coefcoli_in
+            ELSE
+              flag_cvltr(it) = .FALSE.
+            ENDIF
+          ENDIF
+        ENDDO
+        !
+      ELSE ! iflag_con .ne. 3
+        flag_cvltr(:) = .FALSE.
+      ENDIF
+      !
+      ! print out all tracer flags
+      !
+      WRITE(lunout, *) 'print out all tracer flags'
+      WRITE(lunout, *) 'type_trac      =', type_trac
+      WRITE(lunout, *) 'config_inca    =', config_inca
+      WRITE(lunout, *) 'iflag_con_trac =', iflag_con_trac
+      WRITE(lunout, *) 'iflag_con      =', iflag_con
+      WRITE(lunout, *) 'convscav       =', convscav
+      WRITE(lunout, *) 'iflag_lscav    =', iflag_lscav
+      WRITE(lunout, *) 'aerosol        =', aerosol
+      WRITE(lunout, *) 'iflag_the_trac =', iflag_the_trac
+      WRITE(lunout, *) 'iflag_thermals =', iflag_thermals
+      WRITE(lunout, *) 'iflag_vdf_trac =', iflag_vdf_trac
+      WRITE(lunout, *) 'pbl_flg        =', pbl_flg
+      WRITE(lunout, *) 'lessivage      =', lessivage
+      write(lunout, *)  'flag_cvltr    = ', flag_cvltr
+
+      IF (lessivage .AND. ANY(type_trac == ['inca', 'inco'])) &
+              CALL abort_physic('phytrac', 'lessivage=T config_inca=inca impossible', 1)
+      !
     ENDIF ! of IF (debutphy)
     !############################################ END INITIALIZATION #######
 
-    DO k=1,klev
-       DO i=1,klon
-          zmasse(i,k)=(paprs(i,k)-paprs(i,k+1))/rg
-       ENDDO
+    DO k = 1, klev
+      DO i = 1, klon
+        zmasse(i, k) = (paprs(i, k) - paprs(i, k + 1)) / rg
+      ENDDO
     ENDDO
     !
     IF (id_be > 0) THEN
-       DO k=1,klev
-          DO i=1,klon
-             sourceBE(i,k)=srcbe(i,k)       !RomP  -> pour sortie histrac
-          ENDDO
-       ENDDO
+      DO k = 1, klev
+        DO i = 1, klon
+          sourceBE(i, k) = srcbe(i, k)       !RomP  -> pour sortie histrac
+        ENDDO
+      ENDDO
     ENDIF
 
     !===============================================================================
     !    -- Do specific treatment according to chemestry model or local LMDZ tracers
-    !      
+    !
     !===============================================================================
     IF (type_trac == 'inca') THEN
-       !    -- CHIMIE INCA  config_inca = aero or chem --
-       ! Appel fait en fin de phytrac pour avoir les emissions modifiees par 
-       ! la couche limite et la convection avant le calcul de la chimie 
+      !    -- CHIMIE INCA  config_inca = aero or chem --
+      ! Appel fait en fin de phytrac pour avoir les emissions modifiees par
+      ! la couche limite et la convection avant le calcul de la chimie
 
     ELSE IF (type_trac == 'repr') THEN
-       !   -- CHIMIE REPROBUS --
-       CALL tracreprobus(pdtphys, gmtime, debutphy, julien, &
-            presnivs, xlat, xlon, pphis, pphi, &
-            t_seri, pplay, paprs, sh , &
-            tr_seri)
+      !   -- CHIMIE REPROBUS --
+      CALL tracreprobus(pdtphys, gmtime, debutphy, julien, &
+              presnivs, xlat, xlon, pphis, pphi, &
+              t_seri, pplay, paprs, sh, &
+              tr_seri)
 
     ELSE IF (type_trac == 'co2i') THEN
-       !   -- CO2 interactif --
-       !   -- source is updated with FF and BB emissions 
-       !   -- and net fluxes from ocean and orchidee 
-       !   -- sign convention : positive into the atmosphere
-
-       CALL tracco2i(pdtphys, debutphy, &
-            xlat, xlon, pphis, pphi, &
-            t_seri, pplay, paprs, tr_seri, source)
+      !   -- CO2 interactif --
+      !   -- source is updated with FF and BB emissions
+      !   -- and net fluxes from ocean and orchidee
+      !   -- sign convention : positive into the atmosphere
+
+      CALL tracco2i(pdtphys, debutphy, &
+              xlat, xlon, pphis, pphi, &
+              t_seri, pplay, paprs, tr_seri, source)
     ELSE IF (type_trac == 'inco') THEN      ! Add ThL
-       CALL tracco2i(pdtphys, debutphy, &
-            xlat, xlon, pphis, pphi, &
-            t_seri, pplay, paprs, tr_seri, source)
-
-#ifdef CPP_StratAer
-    ELSE IF (type_trac == 'coag') THEN
-       !   --STRATOSPHERIC AER IN THE STRAT --
-       CALL traccoag(pdtphys, gmtime, debutphy, julien, &
-            presnivs, xlat, xlon, pphis, pphi, &
-            t_seri, pplay, paprs, sh, rh , &
-            tr_seri)
-#endif
+      CALL tracco2i(pdtphys, debutphy, &
+              xlat, xlon, pphis, pphi, &
+              t_seri, pplay, paprs, tr_seri, source)
+
+    ELSE IF (type_trac == 'coag' .AND. CPPKEY_STRATAER) THEN
+      !   --STRATOSPHERIC AER IN THE STRAT --
+      CALL traccoag(pdtphys, gmtime, debutphy, julien, &
+              presnivs, xlat, xlon, pphis, pphi, &
+              t_seri, pplay, paprs, sh, rh, &
+              tr_seri)
     ELSE IF (type_trac == 'lmdz') THEN
-       !    -- Traitement des traceurs avec traclmdz
-       CALL traclmdz(nstep, julien, gmtime, pdtphys, t_seri, paprs, pplay, &
-            cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon,iflag_vdf_trac>=0,sh, &
-            rh, pphi, ustar, wstar, ale_bl, ale_wake,  u10m, v10m, &
-            tr_seri, source, d_tr_cl,d_tr_dec, zmasse)               !RomP
+      !    -- Traitement des traceurs avec traclmdz
+      CALL traclmdz(nstep, julien, gmtime, pdtphys, t_seri, paprs, pplay, &
+              cdragh, coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon, iflag_vdf_trac>=0, sh, &
+              rh, pphi, ustar, wstar, ale_bl, ale_wake, u10m, v10m, &
+              tr_seri, source, d_tr_cl, d_tr_dec, zmasse)               !RomP
     ENDIF
     !======================================================================
@@ -679,96 +670,95 @@
     IF (iflag_con_trac==1) THEN
 
-       DO it=1, nbtr
-          IF ( conv_flg(it) == 0 ) CYCLE
-          IF (iflag_con<2) THEN
-             !--pas de transport convectif
-             d_tr_cv(:,:,it)=0.
-
-          ELSE IF (iflag_con==2) THEN
-             !--ancien transport convectif de Tiedtke
-
-             CALL nflxtr(pdtphys, pmfu, pmfd, pen_u, pde_u, pen_d, pde_d, &
-                  pplay, paprs, tr_seri(:,:,it), d_tr_cv(:,:,it))
-          ELSE   
-             !--nouveau transport convectif de Emanuel
-
-             IF (flag_cvltr(it)) THEN
-                !--nouveau transport convectif de Emanuel avec lessivage convectif
-                !
-                !
-                ccntrAA_3d(:,:) =ccntrAA(it)
-                ccntrENV_3d(:,:)=ccntrENV(it)
-                coefcoli_3d(:,:)=coefcoli(it)
-
-                !--beware this interface is a bit weird because it is called for each tracer 
-                !--with the full array tr_seri even if only item it is processed
-
-                CALL cvltr_scav(pdtphys, da, phi,phi2,d1a,dam, mp,ep,         &
-                     sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,              &     
-                     pmflxr,pmflxs,evap,t_seri,wdtrainA,wdtrainM,             &   
-                     paprs,it,tr_seri,upwd,dnwd,itop_con,ibas_con,            &
-                     ccntrAA_3d,ccntrENV_3d,coefcoli_3d,                      &
-                     d_tr_cv,d_tr_trsp,d_tr_sscav,d_tr_sat,d_tr_uscav,qDi,qPr,&
-                     qPa,qMel,qTrdi,dtrcvMA,Mint,                             &
-                     zmfd1a,zmfphi2,zmfdam)
-
-
-             ELSE  !---flag_cvltr(it).EQ.FALSE
-                !--nouveau transport convectif de Emanuel mais pas de lessivage convectif
-
-                !--beware this interface is a bit weird because it is called for each tracer 
-                !--with the full array tr_seri even if only item it is processed
-                !
-                CALL cvltr_noscav(it,pdtphys, da, phi,mp,wght_cvfd,paprs,pplay, &  !jyg
-                     tr_seri,upwd,dnwd,d_tr_cv)                                !jyg
-
-             ENDIF
-
-          ENDIF !--iflag
-
-          !--on ajoute les tendances
-
-          DO k = 1, klev
-             DO i = 1, klon        
-                tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cv(i,k,it)
-             ENDDO
+      DO it = 1, nbtr
+        IF (conv_flg(it) == 0) CYCLE
+        IF (iflag_con<2) THEN
+          !--pas de transport convectif
+          d_tr_cv(:, :, it) = 0.
+
+        ELSE IF (iflag_con==2) THEN
+          !--ancien transport convectif de Tiedtke
+
+          CALL nflxtr(pdtphys, pmfu, pmfd, pen_u, pde_u, pen_d, pde_d, &
+                  pplay, paprs, tr_seri(:, :, it), d_tr_cv(:, :, it))
+        ELSE
+          !--nouveau transport convectif de Emanuel
+
+          IF (flag_cvltr(it)) THEN
+            !--nouveau transport convectif de Emanuel avec lessivage convectif
+            !
+            !
+            ccntrAA_3d(:, :) = ccntrAA(it)
+            ccntrENV_3d(:, :) = ccntrENV(it)
+            coefcoli_3d(:, :) = coefcoli(it)
+
+            !--beware this interface is a bit weird because it is called for each tracer
+            !--with the full array tr_seri even if only item it is processed
+
+            CALL cvltr_scav(pdtphys, da, phi, phi2, d1a, dam, mp, ep, &
+                    sigd, sij, wght_cvfd, clw, elij, epmlmMm, eplaMm, &
+                    pmflxr, pmflxs, evap, t_seri, wdtrainA, wdtrainM, &
+                    paprs, it, tr_seri, upwd, dnwd, itop_con, ibas_con, &
+                    ccntrAA_3d, ccntrENV_3d, coefcoli_3d, &
+                    d_tr_cv, d_tr_trsp, d_tr_sscav, d_tr_sat, d_tr_uscav, qDi, qPr, &
+                    qPa, qMel, qTrdi, dtrcvMA, Mint, &
+                    zmfd1a, zmfphi2, zmfdam)
+
+          ELSE  !---flag_cvltr(it).EQ.FALSE
+            !--nouveau transport convectif de Emanuel mais pas de lessivage convectif
+
+            !--beware this interface is a bit weird because it is called for each tracer
+            !--with the full array tr_seri even if only item it is processed
+            !
+            CALL cvltr_noscav(it, pdtphys, da, phi, mp, wght_cvfd, paprs, pplay, &  !jyg
+                    tr_seri, upwd, dnwd, d_tr_cv)                                !jyg
+
+          ENDIF
+
+        ENDIF !--iflag
+
+        !--on ajoute les tendances
+
+        DO k = 1, klev
+          DO i = 1, klon
+            tr_seri(i, k, it) = tr_seri(i, k, it) + d_tr_cv(i, k, it)
           ENDDO
-
-          CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'convection it = '//TRIM(int2str(it)))
-
-       ENDDO ! nbtr
-
-#ifdef CPP_StratAer
-       IF (type_trac=='coag') THEN
-         ! initialize wet deposition flux of sulfur
-         budg_dep_wet_ocs(:)=0.0
-         budg_dep_wet_so2(:)=0.0
-         budg_dep_wet_h2so4(:)=0.0
-         budg_dep_wet_part(:)=0.0
-         ! compute wet deposition flux of sulfur (sum over gases and particles)
-         ! and convert to kg(S)/m2/s
-         DO i = 1, klon
-         DO k = 1, klev
-         DO it = 1, nbtr
-         !do not include SO2 because most of it comes trom the troposphere
-           IF (it==id_OCS_strat) THEN
-             budg_dep_wet_ocs(i)=budg_dep_wet_ocs(i)+d_tr_cv(i,k,it)*(mSatom/mOCSmol) &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-           ELSEIF (it==id_SO2_strat) THEN
-             budg_dep_wet_so2(i)=budg_dep_wet_so2(i)+d_tr_cv(i,k,it)*(mSatom/mSO2mol) &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-           ELSEIF (it==id_H2SO4_strat) THEN
-             budg_dep_wet_h2so4(i)=budg_dep_wet_h2so4(i)+d_tr_cv(i,k,it)*(mSatom/mH2SO4mol) &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-           ELSEIF (it.GT.nbtr_sulgas) THEN
-             budg_dep_wet_part(i)=budg_dep_wet_part(i)+d_tr_cv(i,k,it)*(mSatom/mH2SO4mol)  &
-   *dens_aer_dry*4./3.*RPI*(mdw(it-nbtr_sulgas)/2.)**3 &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-           ENDIF
-         ENDDO
-         ENDDO
-         ENDDO
-       ENDIF
-#endif
+        ENDDO
+
+        CALL minmaxqfi(tr_seri(:, :, it), 0., 1.e33, 'convection it = ' // TRIM(int2str(it)))
+
+      ENDDO ! nbtr
+
+      IF (CPPKEY_STRATAER) THEN
+        IF (type_trac=='coag') THEN
+          ! initialize wet deposition flux of sulfur
+          budg_dep_wet_ocs(:) = 0.0
+          budg_dep_wet_so2(:) = 0.0
+          budg_dep_wet_h2so4(:) = 0.0
+          budg_dep_wet_part(:) = 0.0
+          ! compute wet deposition flux of sulfur (sum over gases and particles)
+          ! and convert to kg(S)/m2/s
+          DO i = 1, klon
+            DO k = 1, klev
+              DO it = 1, nbtr
+                !do not include SO2 because most of it comes trom the troposphere
+                IF (it==id_OCS_strat) THEN
+                  budg_dep_wet_ocs(i) = budg_dep_wet_ocs(i) + d_tr_cv(i, k, it) * (mSatom / mOCSmol) &
+                          * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                ELSEIF (it==id_SO2_strat) THEN
+                  budg_dep_wet_so2(i) = budg_dep_wet_so2(i) + d_tr_cv(i, k, it) * (mSatom / mSO2mol) &
+                          * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                ELSEIF (it==id_H2SO4_strat) THEN
+                  budg_dep_wet_h2so4(i) = budg_dep_wet_h2so4(i) + d_tr_cv(i, k, it) * (mSatom / mH2SO4mol) &
+                          * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                ELSEIF (it>nbtr_sulgas) THEN
+                  budg_dep_wet_part(i) = budg_dep_wet_part(i) + d_tr_cv(i, k, it) * (mSatom / mH2SO4mol)  &
+                          * dens_aer_dry * 4. / 3. * RPI * (mdw(it - nbtr_sulgas) / 2.)**3 &
+                          * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                ENDIF
+              ENDDO
+            ENDDO
+          ENDDO
+        ENDIF
+      END IF
 
     ENDIF ! convection
